diff --git a/sound/soc/sa11x0/ssp.c b/sound/soc/sa11x0/ssp.c
new file mode 100644
index 000000000000..2656df529f96
--- /dev/null
+++ b/sound/soc/sa11x0/ssp.c
@@ -0,0 +1,411 @@
+/*
+ * ASoC SA11x0 SSP DAI driver
+ *
+ * Copyright (C) 2012 Russell King
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * The SA11x0 SSP interface gives us four signals: TXD, RXD, SFRM and SCLK,
+ * and SFRM pulses for each and every word transmitted.  These signals can
+ * be routed to GPIO10(TXD), GPIO11(RXD), GPIO12(SCLK), and GPIO13(SFRM)
+ * when the PPAR_SPR bit it set, along with the appropriate GAFR and GPDR
+ * configuration.  If PPAR_SPR is clear, the SSP shares the same pins with
+ * the MCP.
+ */
+#include <linux/init.h>
+#include <linux/io.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/scatterlist.h>
+#include <linux/slab.h>
+
+#include <sound/core.h>
+#include <sound/dmaengine_pcm.h>
+#include <sound/pcm.h>
+#include <sound/pcm_params.h>
+#include <sound/soc.h>
+
+#include "ssp.h"
+
+#define SA11X0_SSP_CHANNELS_MIN	1
+#define SA11X0_SSP_CHANNELS_MAX	8
+
+/*
+ * This isn't really up to us - it depends how the board implements the
+ * clocking, whether the board uses the on-board clock source, or whether
+ * the SSP is clocked via GPIO19.
+ */
+#define SA11X0_SSP_RATES \
+	(SNDRV_PCM_RATE_8000_192000 | SNDRV_PCM_RATE_CONTINUOUS)
+#define SA11X0_SSP_FORMATS \
+	(SNDRV_PCM_FORMAT_S8		| SNDRV_PCM_FORMAT_U8		| \
+	 SNDRV_PCM_FORMAT_S16_LE	| SNDRV_PCM_FORMAT_U16_LE)
+
+#define BUFFER_SIZE_MAX		65536
+#define PERIOD_SIZE_MIN		32
+#define PERIOD_SIZE_MAX		16384
+#define PERIODS_MIN		2
+#define PERIODS_MAX		256
+
+#define SSCR0		0x60
+#define SSCR0_DSS	(15 << 0)	/* s */
+#define SSCR0_FRF_MOT	(0 << 4)
+#define SSCR0_FRF_TI	(1 << 4)
+#define SSCR0_FRF_NAT	(2 << 4)
+#define SSCR0_SSE	(1 << 7)	/* s */
+#define SSCR0_SCR	(0xff << 8)	/* s */
+#define SSCR1		0x64
+#define SSCR1_RIE	(1 << 0)
+#define SSCR1_TIE	(1 << 1)
+#define SSCR1_LBM	(1 << 2)
+#define SSCR1_SPO	(1 << 3)
+#define SSCR1_SP	(1 << 4)
+#define SSCR1_ECS	(1 << 5)	/* s */
+#define SSDR		0x6c
+#define SSSR		0x74
+
+struct ssp_priv {
+	void __iomem *base;
+	unsigned long clk_hz;
+	u32 cr0;
+	u32 cr1;
+	struct snd_dmaengine_dai_dma_data tx;
+	struct snd_dmaengine_dai_dma_data rx;
+};
+
+static const struct snd_pcm_hardware sa11x0_ssp_pcm_hardware = {
+	.info			= SNDRV_PCM_INFO_MMAP |
+				  SNDRV_PCM_INFO_MMAP_VALID |
+				  SNDRV_PCM_INFO_INTERLEAVED |
+				  SNDRV_PCM_INFO_PAUSE |
+				  SNDRV_PCM_INFO_RESUME,
+	.period_bytes_min	= PERIOD_SIZE_MIN,
+	.period_bytes_max	= PERIOD_SIZE_MAX,
+	.periods_min		= PERIODS_MIN,
+	.periods_max		= PERIODS_MAX,
+	.buffer_bytes_max	= BUFFER_SIZE_MAX,
+	/* This is for playback only */
+	.fifo_size		= 8 * 2,
+};
+
+/*
+ * Constrain the rate according to the bitrate(s) that the interface can
+ * do, which is determined by its input clock and the range of divisors
+ * that we can program (1 to 256 with an initial /2).
+ */
+static int
+sa11x0_ssp_rate_constraint(struct snd_pcm_hw_params *params,
+	struct snd_pcm_hw_rule *rule)
+{
+	struct snd_interval *p = hw_param_interval(params, rule->var);
+	struct ssp_priv *ssp = rule->private;
+	snd_pcm_format_t fmt = params_format(params);
+	struct snd_ratnum ratnum;
+
+	ratnum.num = ssp->clk_hz /
+		(2 * snd_pcm_format_width(fmt) * params_channels(params));
+	ratnum.den_min = 1;
+	ratnum.den_max = 256;
+	ratnum.den_step = 1;
+
+	return snd_interval_ratnum(p, 1, &ratnum, &params->rate_num,
+				   &params->rate_den);
+}
+
+static int
+sa11x0_ssp_startup(struct snd_pcm_substream *substream, struct snd_soc_dai *dai)
+{
+	struct ssp_priv *ssp = snd_soc_dai_get_drvdata(dai);
+	int ret;
+
+	ret = snd_pcm_hw_constraint_step(substream->runtime, 0,
+		SNDRV_PCM_HW_PARAM_PERIOD_BYTES, 32);
+	if (ret)
+		return ret;
+
+	ret = snd_pcm_hw_constraint_step(substream->runtime, 0,
+		SNDRV_PCM_HW_PARAM_BUFFER_BYTES, 32);
+	if (ret)
+		return ret;
+
+	ret = snd_pcm_hw_rule_add(substream->runtime, 0,
+		SNDRV_PCM_HW_PARAM_RATE, sa11x0_ssp_rate_constraint, ssp,
+		SNDRV_PCM_HW_PARAM_RATE, SNDRV_PCM_HW_PARAM_FORMAT,
+		SNDRV_PCM_HW_PARAM_CHANNELS, -1);
+	if (ret)
+		return ret;
+
+	if (!dai->active) {
+		writel_relaxed(ssp->cr0, ssp->base + SSCR0);
+		writel_relaxed(ssp->cr1, ssp->base + SSCR1);
+		ssp->cr0 |= SSCR0_SSE;
+		writel_relaxed(ssp->cr0, ssp->base + SSCR0);
+	}
+
+	return 0;
+}
+
+static void sa11x0_ssp_shutdown(struct snd_pcm_substream *substream,
+	struct snd_soc_dai *dai)
+{
+	if (!dai->active) {
+		struct ssp_priv *ssp = snd_soc_dai_get_drvdata(dai);
+
+		ssp->cr0 &= ~SSCR0_SSE;
+		writel_relaxed(ssp->cr0, ssp->base + SSCR0);
+	}
+}
+
+static int sa11x0_ssp_hw_params(struct snd_pcm_substream *substream,
+	struct snd_pcm_hw_params *params, struct snd_soc_dai *dai)
+{
+	struct ssp_priv *ssp = snd_soc_dai_get_drvdata(dai);
+	snd_pcm_format_t fmt = params_format(params);
+	int width = snd_pcm_format_width(fmt);
+	unsigned int divisor;
+	u32 cr0;
+
+	if (width < 0)
+		return width;
+	if (width < 4 || width > 16)
+		return -EINVAL;
+
+	divisor = ssp->clk_hz / (2 * width * params_channels(params) *
+				params_rate(params));
+	if (divisor == 0)
+		return -EINVAL;
+
+	/* Set the bit-width for the format and the divisor */
+	cr0 = ssp->cr0 & ~(SSCR0_DSS | SSCR0_SCR);
+	/* rate_den is calculated by snd_interval_ratnum() above. */
+	cr0 |= (width - 1) | (divisor - 1) << 8;
+	if (cr0 != ssp->cr0) {
+		ssp->cr0 = cr0;
+		writel_relaxed(cr0, ssp->base + SSCR0);
+	}
+	writel_relaxed(ssp->cr1, ssp->base + SSCR1);
+
+	return 0;
+}
+
+static int sa11x0_ssp_set_sysclk(struct snd_soc_dai *dai, int clk_id,
+	unsigned int freq, int dir)
+{
+	struct ssp_priv *ssp = snd_soc_dai_get_drvdata(dai);
+
+	switch (clk_id) {
+	case SA11X0_SSP_CLK_INT:
+		ssp->cr1 &= ~SSCR1_ECS;
+		ssp->clk_hz = 3686400;
+		break;
+
+	case SA11X0_SSP_CLK_EXT:
+		/*
+		 * The SA11x0 developer's manual section 11.12.10.6 says the
+		 * external clock can be up to 3.6864MHz, but iPAQs supply
+		 * this with up to a 12.288MHz clock, which appears to work.
+		 * We trust that the frequency is correct.
+		 */
+		if (dir != SND_SOC_CLOCK_IN)
+			return -EINVAL;
+		ssp->cr1 |= SSCR1_ECS;
+		ssp->clk_hz = freq;
+		break;
+
+	default:
+		return -EINVAL;
+	}
+
+	return 0;
+}
+
+static int sa11x0_ssp_set_fmt(struct snd_soc_dai *dai, unsigned int fmt)
+{
+	struct ssp_priv *ssp = snd_soc_dai_get_drvdata(dai);
+
+	/* We always generate the clock and frm signals */
+	if ((fmt & SND_SOC_DAIFMT_MASTER_MASK) != SND_SOC_DAIFMT_CBS_CFS)
+		return -EINVAL;
+
+	switch (fmt & SND_SOC_DAIFMT_INV_MASK) {
+	case SND_SOC_DAIFMT_NB_NF:
+		ssp->cr1 &= ~SSCR1_SPO;
+		break;
+
+	case SND_SOC_DAIFMT_IB_NF:
+		ssp->cr1 |= SSCR1_SPO;
+		break;
+
+	default:
+		return -EINVAL;
+	}
+
+	return 0;
+}
+
+static struct snd_soc_dai_ops sa11x0_ssp_ops = {
+	.startup = sa11x0_ssp_startup,
+	.shutdown = sa11x0_ssp_shutdown,
+	.hw_params = sa11x0_ssp_hw_params,
+	.set_sysclk = sa11x0_ssp_set_sysclk,
+	.set_fmt = sa11x0_ssp_set_fmt,
+};
+
+static int sa11x0_ssp_probe(struct snd_soc_dai *dai)
+{
+	struct ssp_priv *ssp = snd_soc_dai_get_drvdata(dai);
+
+	/* Default to TI mode and a bit-width of 16 */
+	ssp->cr0 = SSCR0_FRF_TI | 15;
+
+	/*
+	 * Set the DMA data now - it's needed for the dmaengine backend to
+	 * obtain its DMA channel, in turn its struct device, and therefore
+	 * a struct device to allocate DMA memory against.
+	 */
+	dai->playback_dma_data = &ssp->tx;
+	dai->capture_dma_data = &ssp->rx;
+
+	return 0;
+}
+
+static int sa11x0_ssp_remove(struct snd_soc_dai *dai)
+{
+	return 0;
+}
+
+#ifdef CONFIG_PM
+static int sa11x0_ssp_suspend(struct snd_soc_dai *dai)
+{
+	struct ssp_priv *ssp = snd_soc_dai_get_drvdata(dai);
+
+	writel_relaxed(ssp->cr0 & ~SSCR0_SSE, ssp->base + SSCR0);
+
+	return 0;
+}
+
+static int sa11x0_ssp_resume(struct snd_soc_dai *dai)
+{
+	struct ssp_priv *ssp = snd_soc_dai_get_drvdata(dai);
+
+	writel_relaxed(ssp->cr0 & ~SSCR0_SSE, ssp->base + SSCR0);
+	writel_relaxed(ssp->cr1, ssp->base + SSCR1);
+	if (ssp->cr0 & SSCR0_SSE)
+		writel_relaxed(ssp->cr0, ssp->base + SSCR0);
+
+	return 0;
+}
+#else
+#define sa11x0_ssp_suspend NULL
+#define sa11x0_ssp_resume NULL
+#endif
+
+static struct snd_soc_dai_driver sa11x0_ssp_driver = {
+	.probe = sa11x0_ssp_probe,
+	.remove = sa11x0_ssp_remove,
+	.suspend = sa11x0_ssp_suspend,
+	.resume = sa11x0_ssp_resume,
+	.ops = &sa11x0_ssp_ops,
+	.capture = {
+		.channels_min = SA11X0_SSP_CHANNELS_MIN,
+		.channels_max = SA11X0_SSP_CHANNELS_MAX,
+		.rates = SA11X0_SSP_RATES,
+		.formats = SA11X0_SSP_FORMATS,
+	},
+	.playback = {
+		.channels_min = SA11X0_SSP_CHANNELS_MIN,
+		.channels_max = SA11X0_SSP_CHANNELS_MAX,
+		.rates = SA11X0_SSP_RATES,
+		.formats = SA11X0_SSP_FORMATS,
+	},
+	.symmetric_rates = 1,
+};
+
+static const struct snd_soc_component_driver sa11x0_ssp_component = {
+	.name = "sa11x0-ssp",
+};
+
+static const struct snd_dmaengine_pcm_config sa11x0_ssp_pcm_config = {
+	.prepare_slave_config = snd_dmaengine_pcm_prepare_slave_config,
+	.pcm_hardware = &sa11x0_ssp_pcm_hardware,
+	.prealloc_buffer_size = SZ_64K,
+};
+
+static int sa11x0_ssp_plat_probe(struct platform_device *pdev)
+{
+	struct ssp_priv *ssp;
+	struct resource *res;
+	int ret;
+
+	res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (!res)
+		return -EINVAL;
+
+	ssp = devm_kzalloc(&pdev->dev, sizeof(*ssp), GFP_KERNEL);
+	if (!ssp)
+		return -ENOMEM;
+
+	/* Assume internal clock, as that's what we program initially */
+	ssp->clk_hz = 3686400;
+
+	/*
+	 * FIXME: The generic ASoC dmaengine backend does not allow us to set
+	 * a different FIFO size for the transmit and receive sides of the
+	 * SSP: the transmit has a 8 x 16bit FIFO, but the receive side has
+	 * a 12 x 16bit FIFO.
+	 */
+	ssp->tx.addr = res->start + SSDR;
+	ssp->tx.addr_width = DMA_SLAVE_BUSWIDTH_2_BYTES;
+	ssp->tx.maxburst = 4;
+	ssp->tx.filter_data = "Ser4SSPTr";
+
+	ssp->rx.addr = res->start + SSDR;
+	ssp->rx.addr_width = DMA_SLAVE_BUSWIDTH_2_BYTES;
+	ssp->rx.maxburst = 4;
+	ssp->rx.filter_data = "Ser4SSPRc";
+
+	ssp->base = devm_ioremap_resource(&pdev->dev, res);
+	if (IS_ERR(ssp->base))
+		return PTR_ERR(ssp->base);
+
+	writel_relaxed(ssp->cr0, ssp->base + SSCR0);
+	writel_relaxed(ssp->cr1, ssp->base + SSCR1);
+
+	platform_set_drvdata(pdev, ssp);
+
+	ret = snd_dmaengine_pcm_register(&pdev->dev, &sa11x0_ssp_pcm_config,
+					 SND_DMAENGINE_PCM_FLAG_COMPAT);
+	if (ret)
+		return ret;
+
+	ret = snd_soc_register_component(&pdev->dev, &sa11x0_ssp_component,
+					 &sa11x0_ssp_driver, 1);
+	if (ret)
+		snd_dmaengine_pcm_unregister(&pdev->dev);
+
+	return ret;
+}
+
+static int sa11x0_ssp_plat_remove(struct platform_device *pdev)
+{
+	snd_soc_unregister_component(&pdev->dev);
+	snd_dmaengine_pcm_unregister(&pdev->dev);
+	return 0;
+}
+
+static struct platform_driver sa11x0_ssp_plat_driver = {
+	.driver = {
+		.name = "sa11x0-ssp",
+		.owner = THIS_MODULE,
+	},
+	.probe = sa11x0_ssp_plat_probe,
+	.remove = sa11x0_ssp_plat_remove,
+};
+module_platform_driver(sa11x0_ssp_plat_driver);
+
+MODULE_AUTHOR("Russell King <linux@arm.linux.org.uk>");
+MODULE_DESCRIPTION("SA11x0 SSP/PCM SoC Interface");
+MODULE_LICENSE("GPL");
+MODULE_ALIAS("platform:sa11x0-ssp");
diff --git a/sound/soc/sa11x0/ssp.h b/sound/soc/sa11x0/ssp.h
new file mode 100644
index 000000000000..22f1e5b8f45c
--- /dev/null
+++ b/sound/soc/sa11x0/ssp.h
@@ -0,0 +1,11 @@
+#ifndef SA11X0_SSP_H
+#define SA11X0_SSP_H
+
+/* SSP clock sources */
+#define SA11X0_SSP_CLK_INT	0x11000000
+#define SA11X0_SSP_CLK_EXT	0x11000001
+
+/* SSP audio dividers */
+#define SA11X0_SSP_DIV_SCR	0x11000100
+
+#endif
diff --git a/sound/soc/soc-dmaengine.c b/sound/soc/soc-dmaengine.c
new file mode 100644
index 000000000000..4b1bfce9e641
--- /dev/null
+++ b/sound/soc/soc-dmaengine.c
@@ -0,0 +1,591 @@
+/*
+ * Generic ASoC DMA engine backend
+ *
+ * Copyright (C) 2012 Russell King
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ *
+ * We expect the DMA engine to give accurate residue information,
+ * returning the number of bytes left to complete to the requested
+ * cookie.  We also expect the DMA engine to be able to resume
+ * submitted descriptors after a suspend/resume cycle.
+ */
+#include <linux/dma-mapping.h>
+#include <linux/dmaengine.h>
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/spinlock.h>
+
+#include <sound/core.h>
+#include <sound/soc-dmaengine.h>
+#include <sound/soc.h>
+#include <sound/pcm_params.h>
+
+#define BUFFER_SIZE_MAX		65536
+#define PERIOD_SIZE_MIN		32
+#define PERIOD_SIZE_MAX		16384
+#define PERIODS_MIN		2
+#define PERIODS_MAX		256
+
+struct buf_info {
+	struct scatterlist sg;
+	dma_cookie_t cookie;
+};
+
+struct soc_dma_chan {
+	const struct soc_dma_config *conf;
+	spinlock_t lock;
+	struct dma_chan *chan;
+	struct dma_slave_config cfg;
+	enum dma_transfer_direction dir;
+	unsigned nr_periods;
+	unsigned sg_index;
+	unsigned stopped;
+	unsigned cyclic;
+	dma_cookie_t cyclic_cookie;
+	struct buf_info buf[PERIODS_MAX];
+};
+
+struct soc_dma_info {
+	struct soc_dma_chan *chan[2];
+};
+
+static const struct snd_pcm_hardware soc_dmaengine_hardware = {
+	.info			= SNDRV_PCM_INFO_MMAP |
+				  SNDRV_PCM_INFO_MMAP_VALID |
+				  SNDRV_PCM_INFO_INTERLEAVED |
+				  SNDRV_PCM_INFO_PAUSE |
+				  SNDRV_PCM_INFO_RESUME,
+	.period_bytes_min	= PERIOD_SIZE_MIN,
+	.period_bytes_max	= PERIOD_SIZE_MAX,
+	.periods_min		= PERIODS_MIN,
+	.periods_max		= PERIODS_MAX,
+	.buffer_bytes_max	= BUFFER_SIZE_MAX,
+};
+
+static int soc_dmaengine_submit(struct snd_pcm_substream *substream,
+	struct soc_dma_chan *dma);
+
+static void soc_dmaengine_callback(void *data)
+{
+	struct snd_pcm_substream *substream = data;
+	struct soc_dma_chan *dma = substream->runtime->private_data;
+	int ret;
+
+	snd_pcm_period_elapsed(substream);
+
+	if (!dma->stopped && !dma->cyclic) {
+		spin_lock(&dma->lock);
+		ret = soc_dmaengine_submit(substream, dma);
+		spin_unlock(&dma->lock);
+
+		if (ret == 0)
+			dma_async_issue_pending(dma->chan);
+		else
+			pr_err("%s: failed to submit next DMA buffer\n", __func__);
+	}
+}
+
+static int soc_dmaengine_submit(struct snd_pcm_substream *substream,
+	struct soc_dma_chan *dma)
+{
+	struct dma_async_tx_descriptor *tx;
+	struct dma_chan *ch = dma->chan;
+	struct buf_info *buf;
+	unsigned sg_index;
+
+	sg_index = dma->sg_index;
+
+	buf = &dma->buf[sg_index];
+
+	tx = dmaengine_prep_slave_sg(ch, &buf->sg, 1, dma->dir,
+		DMA_PREP_INTERRUPT | DMA_CTRL_ACK);
+	if (tx) {
+		tx->callback = soc_dmaengine_callback;
+		tx->callback_param = substream;
+
+		buf->cookie = dmaengine_submit(tx);
+
+		sg_index++;
+		if (sg_index >= dma->nr_periods)
+			sg_index = 0;
+		dma->sg_index = sg_index;
+	}
+
+	return tx ? 0 : -ENOMEM;
+}
+
+static int soc_dmaengine_start(struct snd_pcm_substream *substream)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+	struct soc_dma_chan *dma = runtime->private_data;
+	unsigned long flags;
+	unsigned i;
+	int ret = 0;
+
+	if (!dma->cyclic) {
+		spin_lock_irqsave(&dma->lock, flags);
+		for (i = 0; i < dma->nr_periods; i++) {
+			ret = soc_dmaengine_submit(substream, dma);
+			if (ret)
+				break;
+		}
+		spin_unlock_irqrestore(&dma->lock, flags);
+		if (ret == 0) {
+			dma->stopped = 0;
+			dma_async_issue_pending(dma->chan);
+		} else {
+			dma->stopped = 1;
+			dmaengine_terminate_all(dma->chan);
+		}
+	} else {
+		struct dma_async_tx_descriptor *tx;
+
+		tx = dmaengine_prep_dma_cyclic(dma->chan, runtime->dma_addr,
+			snd_pcm_lib_buffer_bytes(substream),
+			snd_pcm_lib_period_bytes(substream), dma->dir,
+			DMA_CTRL_ACK | DMA_PREP_INTERRUPT);
+		if (tx) {
+			tx->callback = soc_dmaengine_callback;
+			tx->callback_param = substream;
+
+			dma->cyclic_cookie = dmaengine_submit(tx);
+			dma_async_issue_pending(dma->chan);
+		}
+	}
+
+	return ret;
+}
+
+static int soc_dmaengine_stop(struct snd_pcm_substream *substream)
+{
+	struct soc_dma_chan *dma = substream->runtime->private_data;
+
+	dma->stopped = 1;
+	dmaengine_terminate_all(dma->chan);
+
+	return 0;
+}
+
+static int soc_dmaengine_open(struct snd_pcm_substream *substream)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+	struct soc_dma_info *info = snd_soc_platform_get_drvdata(rtd->platform);
+	struct soc_dma_chan *dma = info->chan[substream->stream];
+	int ret = 0;
+
+	if (!dma)
+		return -EINVAL;
+
+	runtime->hw = soc_dmaengine_hardware;
+	runtime->hw.fifo_size = dma->conf->fifo_size;
+
+	if (dma->conf->align) {
+		/*
+		 * FIXME: Ideally, there should be some way to query
+		 * this from the DMA engine itself.
+		 *
+		 * It would also be helpful to know the maximum size
+		 * a scatterlist entry can be to set the period size.
+		 */
+		ret = snd_pcm_hw_constraint_step(runtime, 0,
+			SNDRV_PCM_HW_PARAM_PERIOD_BYTES, dma->conf->align);
+		if (ret)
+			goto err;
+
+		ret = snd_pcm_hw_constraint_step(runtime, 0,
+			SNDRV_PCM_HW_PARAM_BUFFER_BYTES, dma->conf->align);
+		if (ret)
+			goto err;
+	}
+
+	runtime->private_data = dma;
+
+ err:
+	return ret;
+}
+
+static int soc_dmaengine_close(struct snd_pcm_substream *substream)
+{
+	return 0;
+}
+
+static int soc_dmaengine_hw_params(struct snd_pcm_substream *substream,
+	struct snd_pcm_hw_params *params)
+{
+	int ret = snd_pcm_lib_malloc_pages(substream,
+			params_buffer_bytes(params));
+
+	return ret < 0 ? ret : 0;
+}
+
+static int soc_dmaengine_prepare(struct snd_pcm_substream *substream)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+	struct soc_dma_chan *dma = runtime->private_data;
+	size_t buf_size = snd_pcm_lib_buffer_bytes(substream);
+	size_t period = snd_pcm_lib_period_bytes(substream);
+	dma_addr_t addr = runtime->dma_addr;
+	unsigned i;
+
+	/* Create an array of sg entries, one for each period */
+	for (i = 0; i < PERIODS_MAX && buf_size; i++) {
+		BUG_ON(buf_size < period);
+
+		sg_dma_address(&dma->buf[i].sg) = addr;
+		sg_dma_len(&dma->buf[i].sg) = period;
+
+		addr += period;
+		buf_size -= period;
+	}
+
+	if (buf_size) {
+		pr_err("DMA buffer size not a multiple of the period size: residue=%zu\n", buf_size);
+		return -EINVAL;
+	}
+
+	dma->nr_periods = i;
+	dma->sg_index = 0;
+
+	return 0;
+}
+
+static int soc_dmaengine_trigger(struct snd_pcm_substream *substream, int cmd)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+	struct soc_dma_chan *dma = runtime->private_data;
+	int ret;
+
+	switch (cmd) {
+	case SNDRV_PCM_TRIGGER_START:
+		ret = soc_dmaengine_start(substream);
+		break;
+
+	case SNDRV_PCM_TRIGGER_STOP:
+		ret = soc_dmaengine_stop(substream);
+		break;
+
+	case SNDRV_PCM_TRIGGER_PAUSE_PUSH:
+	case SNDRV_PCM_TRIGGER_SUSPEND:
+		ret = dmaengine_pause(dma->chan);
+		break;
+
+	case SNDRV_PCM_TRIGGER_PAUSE_RELEASE:
+	case SNDRV_PCM_TRIGGER_RESUME:
+		ret = dmaengine_resume(dma->chan);
+		break;
+
+	default:
+		ret = -EINVAL;
+	}
+
+	return ret;
+}
+
+static snd_pcm_uframes_t soc_dmaengine_pointer(struct snd_pcm_substream *substream)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+	struct soc_dma_chan *dma = runtime->private_data;
+	struct dma_chan *ch = dma->chan;
+	struct dma_tx_state state;
+	unsigned bytes;
+
+	if (dma->cyclic) {
+		ch->device->device_tx_status(ch, dma->cyclic_cookie, &state);
+
+		bytes = snd_pcm_lib_buffer_bytes(substream) - state.residue;
+	} else {
+		unsigned index, pos;
+		size_t period = snd_pcm_lib_period_bytes(substream);
+		unsigned long flags;
+		enum dma_status status;
+		dma_cookie_t cookie;
+
+		/*
+		 * Get the next-to-be-submitted index, and the last submitted
+		 * cookie value.  We use this to obtain the DMA engine state.
+		 */
+		spin_lock_irqsave(&dma->lock, flags);
+		index = dma->sg_index;
+		do {
+			cookie = dma->buf[index].cookie;
+			status = ch->device->device_tx_status(ch, cookie, &state);
+			if (status == DMA_SUCCESS) {
+				index++;
+				if (index > dma->nr_periods)
+					index = 0;
+			}
+		} while (status == DMA_SUCCESS);
+		spin_unlock_irqrestore(&dma->lock, flags);
+
+		/* The end of the current DMA buffer */
+		pos = (index + 1) * period;
+		/* Now take off the residue */
+		bytes = pos - state.residue;
+		/* And correct for wrap-around */
+		if (bytes >= period * dma->nr_periods)
+			bytes -= period * dma->nr_periods;
+	}
+
+	return bytes_to_frames(runtime, bytes);
+}
+
+static int soc_dmaengine_mmap(struct snd_pcm_substream *substream,
+	struct vm_area_struct *vma)
+{
+	struct snd_pcm_runtime *runtime = substream->runtime;
+	struct snd_dma_buffer *buf = runtime->dma_buffer_p;
+
+	return dma_mmap_writecombine(buf->dev.dev, vma,
+		runtime->dma_area, runtime->dma_addr, runtime->dma_bytes);
+}
+
+static struct snd_pcm_ops soc_dmaengine_ops = {
+	.open = soc_dmaengine_open,
+	.close = soc_dmaengine_close,
+	.ioctl = snd_pcm_lib_ioctl,
+	.hw_params = soc_dmaengine_hw_params,
+	.hw_free = snd_pcm_lib_free_pages,
+	.prepare = soc_dmaengine_prepare,
+	.trigger = soc_dmaengine_trigger,
+	.pointer = soc_dmaengine_pointer,
+	.mmap = soc_dmaengine_mmap,
+};
+
+static struct soc_dma_chan *soc_dmaengine_alloc(void)
+{
+	struct soc_dma_chan *dma = kzalloc(sizeof(*dma), GFP_KERNEL);
+	unsigned i;
+
+	if (dma) {
+		spin_lock_init(&dma->lock);
+		for (i = 0; i < PERIODS_MAX; i++)
+			sg_init_table(&dma->buf[i].sg, 1);
+	}
+	return dma;
+}
+
+static struct dma_chan *soc_dmaengine_get(enum dma_transaction_type type,
+	struct soc_dma_config *cfg)
+{
+	dma_cap_mask_t m;
+
+	dma_cap_zero(m);
+	dma_cap_set(type, m);
+	return dma_request_channel(m, cfg->filter, cfg->data);
+}
+
+static int soc_dmaengine_request(struct soc_dma_chan *dma,
+	struct soc_dma_config *cfg, unsigned stream)
+{
+	int ret;
+
+	dma->conf = cfg;
+	dma->chan = soc_dmaengine_get(DMA_CYCLIC, cfg);
+	if (!dma->chan)
+		dma->chan = soc_dmaengine_get(DMA_SLAVE, cfg);
+	else
+		dma->cyclic = 1;
+	if (!dma->chan) {
+		ret = -ENXIO;
+		goto err_dma_req;
+	}
+
+	if (stream == SNDRV_PCM_STREAM_PLAYBACK) {
+		dma->dir = DMA_MEM_TO_DEV;
+		dma->cfg.direction = DMA_MEM_TO_DEV;
+		dma->cfg.dst_addr = cfg->reg;
+		dma->cfg.dst_addr_width = cfg->width;
+		dma->cfg.dst_maxburst = cfg->maxburst;
+	} else {
+		dma->dir = DMA_DEV_TO_MEM;
+		dma->cfg.direction = DMA_DEV_TO_MEM;
+		dma->cfg.src_addr = cfg->reg;
+		dma->cfg.src_addr_width = cfg->width;
+		dma->cfg.src_maxburst = cfg->maxburst;
+	}
+
+	ret = dmaengine_slave_config(dma->chan, &dma->cfg);
+	if (ret)
+		goto err_dma_cfg;
+
+	return 0;
+
+ err_dma_cfg:
+	dma_release_channel(dma->chan);
+	dma->chan = NULL;
+ err_dma_req:
+	return ret;
+}
+
+static void soc_dmaengine_release(struct soc_dma_chan *dma)
+{
+	if (dma && dma->chan)
+		dma_release_channel(dma->chan);
+	kfree(dma);
+}
+
+static int soc_dmaengine_preallocate_buffer(struct snd_pcm *pcm,
+	unsigned stream, struct soc_dma_chan *dma)
+{
+	struct snd_pcm_substream *substream = pcm->streams[stream].substream;
+	int ret = 0;
+
+	if (substream) {
+		struct snd_dma_buffer *buf = &substream->dma_buffer;
+
+		buf->dev.type = SNDRV_DMA_TYPE_DEV;
+		buf->dev.dev = dma->chan->device->dev;
+		buf->private_data = NULL;
+		buf->area = dma_alloc_writecombine(buf->dev.dev,
+				BUFFER_SIZE_MAX, &buf->addr, GFP_KERNEL);
+		if (!buf->area)
+			return -ENOMEM;
+
+		buf->bytes = BUFFER_SIZE_MAX;
+	}
+	return ret;
+}
+
+static int soc_dmaengine_pcm_new(struct snd_soc_pcm_runtime *rtd)
+{
+	struct snd_pcm *pcm = rtd->pcm;
+	struct snd_soc_dai *cpu_dai = rtd->cpu_dai;
+	struct soc_dma_info *info;
+	unsigned stream;
+	int ret = 0;
+
+	if (!cpu_dai)
+		return -EINVAL;
+
+	if (!cpu_dai->playback_dma_data &&
+	    !cpu_dai->capture_dma_data) {
+		pr_err("soc_dmaengine: %s has no cpu_dai DMA data - incorrect probe ordering?\n",
+			rtd->card->name);
+		return -EINVAL;
+	}
+
+	info = kzalloc(sizeof(*info), GFP_KERNEL);
+	if (!info)
+		return -ENOMEM;
+
+	for (stream = 0; stream < ARRAY_SIZE(pcm->streams); stream++) {
+		struct soc_dma_config *cfg = NULL;
+		struct soc_dma_chan *dma;
+
+		if (stream == SNDRV_PCM_STREAM_PLAYBACK)
+			cfg = cpu_dai->playback_dma_data;
+		else if (stream == SNDRV_PCM_STREAM_CAPTURE)
+			cfg = cpu_dai->capture_dma_data;
+
+		if (!cfg)
+			continue;
+
+		info->chan[stream] = dma = soc_dmaengine_alloc();
+		if (!dma) {
+			ret = -ENOMEM;
+			break;
+		}
+
+		ret = soc_dmaengine_request(dma, cfg, stream);
+		if (ret)
+			return ret;
+
+		ret = soc_dmaengine_preallocate_buffer(pcm, stream, dma);
+		if (ret)
+			break;
+	}
+
+	if (ret) {
+		for (stream = 0; stream < ARRAY_SIZE(info->chan); stream++)
+			soc_dmaengine_release(info->chan[stream]);
+		kfree(info);
+	} else {
+		snd_soc_platform_set_drvdata(rtd->platform, info);
+	}
+
+	return ret;
+}
+
+/*
+ * Use write-combining memory here: the standard ALSA
+ * snd_free_dev_pages() doesn't support this.
+ */
+static void soc_dmaengine_pcm_free(struct snd_pcm *pcm)
+{
+	unsigned stream;
+
+	for (stream = 0; stream < ARRAY_SIZE(pcm->streams); stream++) {
+		struct snd_pcm_substream *substream = pcm->streams[stream].substream;
+		struct snd_dma_buffer *buf;
+
+		if (!substream)
+			continue;
+		buf = &substream->dma_buffer;
+		if (!buf->area)
+			continue;
+
+		if (buf->dev.type == SNDRV_DMA_TYPE_DEV)
+			dma_free_writecombine(buf->dev.dev, buf->bytes,
+					      buf->area, buf->addr);
+		else
+			snd_dma_free_pages(buf);
+		buf->area = NULL;
+	}
+}
+
+/*
+ * This is annoying - we can't have symetry with .pcm_new because .pcm_free
+ * is called after the runtime information has been removed.  It would be
+ * better if we could find somewhere else to store our soc_dma_info pointer.
+ */
+static int soc_dmaengine_plat_remove(struct snd_soc_platform *platform)
+{
+	struct soc_dma_info *info = snd_soc_platform_get_drvdata(platform);
+	unsigned stream;
+
+	for (stream = 0; stream < ARRAY_SIZE(info->chan); stream++)
+		soc_dmaengine_release(info->chan[stream]);
+	kfree(info);
+
+	return 0;
+}
+
+static struct snd_soc_platform_driver soc_dmaengine_platform = {
+	.remove = soc_dmaengine_plat_remove,
+	.pcm_new = soc_dmaengine_pcm_new,
+	.pcm_free = soc_dmaengine_pcm_free,
+	.ops = &soc_dmaengine_ops,
+	/* Wait until the cpu_dai has been probed */
+	.probe_order = SND_SOC_COMP_ORDER_LATE,
+};
+
+static int soc_dmaengine_probe(struct platform_device *pdev)
+{
+	return snd_soc_register_platform(&pdev->dev, &soc_dmaengine_platform);
+}
+
+static int soc_dmaengine_remove(struct platform_device *pdev)
+{
+	snd_soc_unregister_platform(&pdev->dev);
+	return 0;
+}
+
+static struct platform_driver soc_dmaengine_driver = {
+	.driver = {
+		.name = "soc-dmaengine",
+		.owner = THIS_MODULE,
+	},
+	.probe = soc_dmaengine_probe,
+	.remove = soc_dmaengine_remove,
+};
+
+module_platform_driver(soc_dmaengine_driver);
+
+MODULE_AUTHOR("Russell King");
+MODULE_DESCRIPTION("ALSA SoC DMA engine driver");
+MODULE_LICENSE("GPL v2");
+MODULE_ALIAS("platform:soc-dmaengine");
